> For the complete documentation index, see [llms.txt](https://docs.hashkey.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hashkey.id/protocol/contract-api-reference/credential.md).

# Credential

#### Set Transferable

Credential could be transferable or non-transferable. The function can reverse it. Can only be invoked by issuer or HashKey DID.

```solidity
function reverseTransferable() public onlyControllers;
```

#### Set Supply

The supply of a credential can be fixed. Can only be invoked by issuer or HashKey DID.

```solidity
function setSupply(uint256 tokenId, uint256 supply) public onlyControllers;
```

* tokenId: DID token id
* supply: max supply

#### Get URI

Retrieve the tokenURI (i.e., the link to the metadata) associated with a given tokenId.

```solidity
function uri(uint256 tokenId) public view override returns (string memory);
```

* tokenId: DID token id

#### Issue DeedGrain

An institution can obtain evidence signed by a HashKey DID and use that evidence to issue DeedGrain.

```solidity
function issueDG (string memory _name, string memory _symbol, string memory _baseUri, bytes memory _evidence, bool _transferable) public;
```

* \_name: credential name
* \_symbol: credential symbol
* \_baseUri: credential baseUri
* \_evidence: signature signed by HashKey DID
* \_transferable: whether DeedGrain is transferable


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hashkey.id/protocol/contract-api-reference/credential.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
